<?php
// Set global data - all options defined here.
define('_PAGE_ROOT_', 'ng/index.php');

// Parse the URL
$uri = substr($_SERVER['PHP_SELF'], strlen(_PAGE_ROOT_) + 2);
$pgs = explode('/', $uri);

// Describe the URI map, further mapping can be done at each controller
// inside of the map method.
$map['default']    = array('views',   'home');
$map['year']       = array('views',   'year');
$map['month']      = array('views',   'month');
$map['week']       = array('views',   'week');
$map['day']        = array('views',   'day');
$map['help']       = array('help',    'contents');
$map['control']    = array('control', 'map');
$map['submit']     = array('actions', 'submit');
$map['subscribe']  = array('actions', 'subscribe');
$map['download']   = array('actions', 'download');
$map['error']      = array('actions', 'error');
$map['request']    = array('actions', 'request');
$map['rss']        = array('feeds',   'rss');
$map['csv']        = array('feeds',   'csv');

// Map the first section of the URI to a controller and action
if ( isset($map[$pgs[0]]) ) {
	$action = $map[$pgs[0]];
	array_shift($pgs);
} else {
	$action = $map['default'];
}

// Cleaner format
$controller_name   =  $action[0];
$controller_class  =  ucfirst($controller_name);
$controller_action =  $action[1];
$controller_params =& $pgs; 

// Load the controller
require 'Controllers/'.$controller_name.'.php';

// Instantiate the controller
$controller = new $controller_class;

// Call the action
$controller->$controller_action($controller_params);
?>